$!-----------------------------------------------------------------'f$verify(0)
$! BUILD_HTTPD.COM
$!
$! P1 ... P6  "SSL" to build with WASD OpenSSL distribution
$! P1 ... P6  "OPENSSL" to build with standard OpenSSL distribution
$! P1 ... P6  "BUILD" to compile/link, "LINK" to link only,
$!            "BUILD_LOCAL" to compile/link using local VMS and C RTL versions
$! P1 ... P6  "DBUG" compiles with debug statements
$! P1 ... P6  PERSONA_STUB (force compilation of Persona "stub" on VMS 6.2ff) 
$! P1 ... P6  PERSONA_MACRO (force compilation/linkage of PERSONA Macro) 
$! P1 ... P6  "JUST:module" to compile just that module
$!
$! By default the software is built with a base compliance to VMS V6.0.
$! This is done to make the object modules as broadly portable as possible.
$! Using BUILD_LOCAL will build against whatever version of VMS and C RTL is
$! available on the local system.  This may provide run-time efficiencies, etc.
$! Note however that the package is only extensively tested using the
$! base-level build, so unexpected behaviours (i.e. bugs ;^) may be revealed
$! by the different build and run-time environment.
$! 
$! For a non-WASD-default location for the OpenSSL compile-time environment
$! use the VMS OpenSSL standard logical locations (i.e. SSLROOT).
$!
$! 28-OCT-2001  MGD  PERSONA_MACRO/PERSONA.MAR
$! 01-JUL-2001  MGD  further refinement
$! 18-MAY-2001  MGD  THROTTLE.C, FAO.C modules
$! 07-APR-2001  MGD  explicitly build the link options file,
$!                   use OpenSSL directory logicals
$! 13-FEB-2001  MGD  AUTHIDENT.C module
$! 01-OCT-2000  MGD  PERSONA.C module
$! 12-SEP-2000  MGD  make OpenSSL directory determination more flexible
$! 09-AUG-2000  MGD  WASD_BUILD_DEFINES
$! 13-JUN-2000  MGD  v7.1,
$!                   SERVICE.C module
$! 05-MAR-2000  MGD  v7.0,
$!                   ODS (extended file specification) support,
$!                   OpenSSL v0.9.5 support
$! 23-DEC-1999  MGD  v6.1.2,
$!                   RELAXED_ANSI standard (DECC v6.2)
$! 28-AUG-1999  MGD  v6.1,
$!                   remove support for NETLIB,
$!                   support for OpenSSL v0.9.4,
$!                   remove support for SSLeay
$! 02-APR-1999  MGD  generalize for OpenSSL v0.9.3
$! 24-DEC-1998  MGD  HTTPd version 6,
$!                   add proxy modules,
$!                   suppress informational messages (DECC 5.7)
$! 03-JUL-1998  MGD  SSLeay v0.9.0b,
$!                   build for TCPware in UCX compatibility mode
$! 14-MAY-1998  MGD  add defines for __VMS_VER, __CRTL_VER, __VMS_V6_SOURCE
$!                   (ensure v7.1 compilations can be executed on v6.n),
$!                   distributing as .OBJ ... need UCX and NETLIB object files
$! 07-JAN-1998  MGD  HTTPd version 5
$!                   added SSL (SSLeay) build support
$!                   removed optimization, seemed to be inducing problems
$! 07-SEP-1997  MGD  modified to support DBUG and to retain NETLIB objects
$! 23-JUL-1997  MGD  MultiNet dropped in favour of NETLIB 2.1
$! 01-FEB-1997  MGD  HTTPd version 4
$! 06-JAN-1996  MGD  build for either UCX or MultiNet
$! 01-DEC-1995  MGD  HTTPd version 3
$! 24-MAY-1995  MGD  build for AXP systems
$! 20-DEC-1994  MGD  multi-threaded server
$! 20-JUN-1994  MGD  single-threaded server
$!-----------------------------------------------------------------------------
$!
$!! SET VERIFY
$ SET CONTROL=Y
$ ON CONTROLY THEN GOTO FINISHED
$ DEBUGTRACE = 0
$ BUILD_BASE_V60 = "_VMS_V6_SOURCE,__VMS_VER=60000000,__CRTL_VER=60000000"
$ BUILD_BASE = BUILD_BASE_V60
$ ARCH_NAME = F$EDIT(F$GETSYI("ARCH_NAME"),"UPCASE") 
$ IF ARCH_NAME .EQS. "ALPHA" THEN ARCH_NAME = "AXP"
$ VMS_VERSION = F$GETSYI("VERSION")
$ VMS_VERSION = F$INTEGER(F$EXTRACT(1,1,VMS_VERSION)) * 10 +-
                F$INTEGER(F$EXTRACT(3,1,VMS_VERSION))
$ PREVDEFAULT = F$ENVIRONMENT("DEFAULT")
$ PROCEDURE = F$ENVIRONMENT("PROCEDURE")
$ DEFAULT = F$PARSE(PROCEDURE,,,"DEVICE") + F$PARSE(PROCEDURE,,,"DIRECTORY")
$ SET DEFAULT 'DEFAULT'
$!
$ JUST = ""
$ IF F$ELEMENT(0,":",P1) .EQS. "JUST" THEN JUST = F$ELEMENT(1,":",P1)
$ IF F$ELEMENT(0,":",P2) .EQS. "JUST" THEN JUST = F$ELEMENT(1,":",P2)
$ IF F$ELEMENT(0,":",P3) .EQS. "JUST" THEN JUST = F$ELEMENT(1,":",P3)
$ IF F$ELEMENT(0,":",P4) .EQS. "JUST" THEN JUST = F$ELEMENT(1,":",P4)
$ IF F$ELEMENT(0,":",P5) .EQS. "JUST" THEN JUST = F$ELEMENT(1,":",P5)
$ IF F$ELEMENT(0,":",P6) .EQS. "JUST" THEN JUST = F$ELEMENT(1,":",P6)
$!
$ IF P1 .EQS. "BUILD_LOCAL" .OR. P2 .EQS. "BUILD_LOCAL" .OR. -
     P3 .EQS. "BUILD_LOCAL" .OR. P4 .EQS. "BUILD_LOCAL" .OR. -
     P5 .EQS. "BUILD_LOCAL" .OR. P6 .EQS. "BUILD_LOCAL"
$ THEN
$    BUILD_LOCAL = 1
$ ELSE
$    BUILD_LOCAL = 0
$ ENDIF
$!
$ IF P1 .EQS. "DBUG" .OR. P2 .EQS. "DBUG" .OR. -
     P3 .EQS. "DBUG" .OR. P4 .EQS. "DBUG" .OR. -
     P5 .EQS. "DBUG" .OR. P6 .EQS. "DBUG"
$ THEN
$    DBUG = "DBUG"
$ ELSE
$    DBUG = ""
$ ENDIF
$!
$ IF P1 .EQS. "PERSONA_STUB" .OR. P2 .EQS. "PERSONA_STUB" .OR. -
     P3 .EQS. "PERSONA_STUB" .OR. P4 .EQS. "PERSONA_STUB" .OR. -
     P5 .EQS. "PERSONA_STUB" .OR. P6 .EQS. "PERSONA_STUB"
$ THEN
$    PERSONA_STUB = 1
$ ELSE
$    PERSONA_STUB = 0
$ ENDIF
$!
$!(BUILD_HTTPD_PERSONA_MACRO is a symbol assigned by INSTALL.COM, etc.)
$ IF P1 .EQS. "PERSONA_MACRO" .OR. P2 .EQS. "PERSONA_MACRO" .OR. -
     P3 .EQS. "PERSONA_MACRO" .OR. P4 .EQS. "PERSONA_MACRO" .OR. -
     P5 .EQS. "PERSONA_MACRO" .OR. P6 .EQS. "PERSONA_MACRO" .OR. -
     F$TYPE(BUILD_HTTPD_PERSONA_MACRO) .NES. ""
$ THEN
$    IF ARCH_NAME .NES. "VAX"
$    THEN
$       TYPE SYS$INPUT

  ***************************************
  *  PERSONA.MAR only supported for VAX *
  ***************************************

$       EXIT
$    ENDIF
$    PERSONA_STUB = 0
$    PERSONA_MACRO = 1
$ ELSE
$    PERSONA_MACRO = 0
$ ENDIF
$!
$ IF DEBUGTRACE
$ THEN
$    DEBUGQUAL == "/DEBUG"
$    TRACEQUAL == "/TRACE"
$ ELSE
$    DEBUGQUAL == "/NODEBUG"
$    TRACEQUAL == "/NOTRACE"
$ ENDIF
$!
$ SESOLA = ""
$ SESOLA_EXE = ""
$ SESOLA_OBJ = ""
$ SESOLA_INCLUDED = "Without SSL"
$ OPENSSL = 0
$ SSL_ROOT = ""
$ SSL_INCLUDE = ""
$!
$ IF P1 .EQS. "SSL" .OR. P2 .EQS. "SSL" .OR. -
     P3 .EQS. "SSL" .OR. P4 .EQS. "SSL" .OR. -
     P5 .EQS. "SSL" .OR. P6 .EQS. "SSL"
$ THEN
$!
$!   (search for latest version in default WASD location)
$    SSL_ROOT_LOOP:
$       TMP_DIR = F$SEARCH("HT_ROOT:[SRC]OPENSSL-*_*_*.DIR")
$       IF TMP_DIR .EQS. "" THEN GOTO END_SSL_ROOT_LOOP
$       SSL_ROOT_POS = F$LOCATE("]OPENSSL",TMP_DIR)
$       SSL_ROOT = F$EXTRACT(0,SSL_ROOT_POS,TMP_DIR) + "." + -
                  F$EXTRACT(SSL_ROOT_POS+1,999,TMP_DIR) - ".DIR;1"
$       GOTO SSL_ROOT_LOOP
$    END_SSL_ROOT_LOOP:
$!
$    OPENSSL = 0
$    IF F$LOCATE("OPENSSL",SSL_ROOT) .LT. F$LENGTH(SSL_ROOT) THEN OPENSSL = 1
$!
$    IF .NOT. OPENSSL
$    THEN
$       TYPE SYS$INPUT

  ****************************************
  *  WASD OpenSSL directory not located  *
  ****************************************

$       GOTO FINISHED
$    ENDIF
$!
$    SSL_ROOT = SSL_ROOT + "]"
$    SSL_ROOT_DEV = F$PARSE(SSL_ROOT,,,"DEVICE","NO_CONCEAL")
$    SSL_ROOT_DIR = F$PARSE(SSL_ROOT,,,"DIRECTORY","NO_CONCEAL") - "]["
$    SSL_ROOT = SSL_ROOT_DEV + -
        F$EXTRACT(0,F$LENGTH(SSL_ROOT_DIR)-1,SSL_ROOT_DIR) + ".]"
$    DEFINE /NOLOG /PROCESS /TRANSLATION=CONCEALED SSLROOT 'SSL_ROOT'
$    DEFINE /NOLOG /PROCESS OPENSSL SSLROOT:[INCLUDE.OPENSSL]
$    IF F$SEARCH("SSLROOT:[INCLUDE.OPENSSL]OPENSSLCONF.H") .EQS. "" .AND. - 
        F$SEARCH("SSLROOT:[WASD]OPENSSLCONF_''ARCH_NAME'.H") .EQS. "" 
$    THEN
$       TYPE SYS$INPUT

  ******************************************
  *  OpenSSL OPENSSLCONF.H file not found  *
  ******************************************

$       GOTO FINISHED
$    ENDIF
$!   (HTTPD v7.2ff requires structures defined in SSL_LOCL.H)
$    IF F$SEARCH("SSLROOT:[SSL]SSL_LOCL.H") .EQS. "" .AND. - 
        F$SEARCH("SSLROOT:[WASD]SSL_LOCL.H") .EQS. "" 
$    THEN
$       TYPE SYS$INPUT

  ***************************************
  *  OpenSSL SSL_LOCL.H file not found  *
  ***************************************

$       GOTO FINISHED
$    ENDIF
$!
$    SESOLA = "SESOLA"
$    SESOLA_EXE = "_SSL"
$    SESOLA_OBJ = "_SSL"
$    SESOLA_INCLUDED = "WASD OpenSSL from " + F$TRNLNM("SSLROOT") - ".]" + "]"
$!
$ ENDIF
$!
$ IF P1 .EQS. "OPENSSL" .OR. P2 .EQS. "OPENSSL" .OR. -
     P3 .EQS. "OPENSSL" .OR. P4 .EQS. "OPENSSL" .OR. -
     P5 .EQS. "OPENSSL" .OR. P6 .EQS. "OPENSSL"
$ THEN
$!
$    IF F$TRNLNM("SSLROOT") .EQS. ""
$    THEN
$       TYPE SYS$INPUT

  ***********************************
  *  OpenSSL directory not located  *
  ***********************************

$       GOTO FINISHED
$    ENDIF
$!
$    SESOLA = "SESOLA"
$    SESOLA_EXE = "_SSL"
$    SESOLA_OBJ = "_SSL"
$    SESOLA_INCLUDED = "OpenSSL from " + F$TRNLNM("SSLROOT") - ".]" + "]"
$    DEFINE /NOLOG /PROCESS OPENSSL SSLROOT:[INCLUDE.OPENSSL]
$!
$ ENDIF
$!
$ IF BUILD_LOCAL 
$    THEN CC_DEFINES = ""
$    ELSE CC_DEFINES = BUILD_BASE
$ ENDIF
$ IF F$TRNLNM("WASD_BUILD_DEFINES") .NES. "" -
     THEN CC_DEFINES = F$TRNLNM("WASD_BUILD_DEFINES")
$ IF DBUG .NES. ""
$ THEN
$    IF CC_DEFINES .NES. "" THEN CC_DEFINES = CC_DEFINES + ","
$    CC_DEFINES = CC_DEFINES + DBUG
$ ENDIF
$ IF SESOLA .NES. ""
$ THEN
$    IF CC_DEFINES .NES. "" THEN CC_DEFINES = CC_DEFINES + ","
$    CC_DEFINES = CC_DEFINES + SESOLA
$ ENDIF
$ IF CC_DEFINES .NES. "" THEN CC_DEFINES = " /DEFINE=(" + CC_DEFINES + ")"
$!
$ WRITE SYS$OUTPUT "Building for ""''ARCH_NAME'"" architecture"
$ IF SESOLA_INCLUDED .NES. "" THEN WRITE SYS$OUTPUT SESOLA_INCLUDED
$!
$ IF P1 .EQS. "WARN" .OR. P2 .EQS. "WARN" .OR. -
     P3 .EQS. "WARN" .OR. P4 .EQS. "WARN" .OR. -
     P5 .EQS. "WARN" .OR. P6 .EQS. "WARN"
$ THEN
$    WARN = ""
$ ELSE
$    IF ARCH_NAME .EQS. "VAX"
$       THEN WARN = " /NOWARNING"
$       ELSE WARN = " /WARNING=(NOINFORM,DISABLE=(PREOPTW))"
$    ENDIF
$ ENDIF
$!
$ IF ARCH_NAME .EQS. "VAX"
$ THEN
$    OBJ_DIR = "[.OBJ_VAX]"
$    IF F$SEARCH("OBJ_VAX.DIR") .EQS. "" THEN CREATE /DIR 'OBJ_DIR'
$    CC_OPTIONS = "/DECC /STAND=RELAXED_ANSI /PREFIX=ALL /OPTIMIZE ''DEBUGQUAL'''WARN'"
$ ELSE
$    OBJ_DIR = "[.OBJ_AXP]"
$    IF F$SEARCH("OBJ_AXP.DIR") .EQS. "" THEN CREATE /DIR 'OBJ_DIR'
$    CC_OPTIONS = "/STAND=RELAXED_ANSI /PREFIX=ALL /OPTIMIZE ''DEBUGQUAL'''WARN'"
$ ENDIF
$!
$ IF P1 .EQS. "LINKMAP" .OR. P2 .EQS. "LINKMAP" .OR. -
     P3 .EQS. "LINKMAP" .OR. P4 .EQS. "LINKMAP" .OR. -
     P5 .EQS. "LINKMAP" .OR. P6 .EQS. "LINKMAP"
$ THEN
$    LINKMAP = " /MAP=HTTPD''SESOLA_EXE'.MAP /FULL"
$    IF P1 .EQS. "LINKMAP" THEN P1 = "LINK"
$    IF P2 .EQS. "LINKMAP" THEN P2 = "LINK"
$    IF P3 .EQS. "LINKMAP" THEN P3 = "LINK"
$    IF P4 .EQS. "LINKMAP" THEN P4 = "LINK"
$    IF P5 .EQS. "LINKMAP" THEN P5 = "LINK"
$    IF P6 .EQS. "LINKMAP" THEN P6 = "LINK"
$ ELSE
$    LINKMAP = ""
$ ENDIF
$!
$ IF P1 .EQS. "LINK" .OR. P2 .EQS. "LINK" .OR. -
     P3 .EQS. "LINK" .OR. P4 .EQS. "LINK" .OR. -
     P5 .EQS. "LINK" .OR. P6 .EQS. "LINK" THEN GOTO LINK
$!
$! ***********
$! * COMPILE *
$! ***********
$!
$ SET NOON
$ SET VERIFY
$ IF JUST .NES. "" THEN GOTO 'JUST'
$ ADMIN:   CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'Admin    Admin
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ AUTH:    CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'Auth     Auth
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ AUTHAGENT:    CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'AuthAgent  AuthAgent
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ AUTHCACHE:    CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'AuthCACHE  AuthCache
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ AUTHCONFIG:    CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'AuthConfig  AuthConfig
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ AUTHHTA:    CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'AuthHTA  AuthHTA
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ AUTHHTL:    CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'AuthHTL  AuthHTL
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ AUTHIDENT:    CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'AuthIdent  AuthIdent
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ AUTHVMS:    CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'AuthVMS  AuthVMS
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ BASIC:   CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'Basic    Basic
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ CACHE:   CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'Cache    Cache
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ CGI:     CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'CGI      CGI
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ CLI:     CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'CLI      CLI
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ CONFIG:  CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'Config   Config
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ CONTROL: CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'Control  Control
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ DCL:     CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'Dcl      Dcl
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ DECNET:  CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'DECnet   DECnet
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ DESCR:   CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'Descr    Descr
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ DIR:     CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'Dir      Dir
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ DIGEST:  CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'Digest   Digest
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ ERROR:   CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'Error    Error
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ FAO:     CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'FAO       FAO
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ FILE:    CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'File     File
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ FILEDOT:  CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'FileDot FileDot
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ GRAPH:   CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'Graph    Graph
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ HTADMIN: CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'HTAdmin  HTAdmin
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ HTTPD:   CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'HTTPd    HTTPd
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ ISMAP:   CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'IsMap    IsMap
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ LOGGING: CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'Logging  Logging
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ MAPURL:  CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'MapUrl   MapUrl
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ MD5:     CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'MD5      MD5
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ MENU:    CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'Menu     Menu
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ MSG:     CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'Msg      Msg
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ NET:     CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'Net      Net
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ ODS:     CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'ODS      ODS
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ PERSONA:
$    IF ARCH_NAME .EQS. "VAX" .AND. PERSONA_MACRO
$    THEN
$       PERSONA_DEFINES = CC_DEFINES - ")" + ",PERSONA_MACRO)"
$       CC 'CC_OPTIONS''PERSONA_DEFINES' /OBJ='OBJ_DIR'Persona_macro Persona
$    ELSE
$       IF VMS_VERSION .LT. 62 .OR. PERSONA_STUB
$       THEN
$          PERSONA_DEFINES = CC_DEFINES - ")" + ",PERSONA_STUB)"
$          CC 'CC_OPTIONS''PERSONA_DEFINES' /OBJ='OBJ_DIR'Persona_stub Persona
$       ELSE
$          CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'Persona  Persona
$       ENDIF
$    ENDIF
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ PROXY:   CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'Proxy    Proxy
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ PROXYCACHE:  CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'ProxyCache  ProxyCache
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ PROXYMAINT:  CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'ProxyMaint  ProxyMaint
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ PUT:     CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'Put      Put
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ REQUEST: CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'Request  Request
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ SERVICE:     CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'SERVICE      SERVICE
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ SSI:     CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'SSI      SSI
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ SESOLA:
$ IF SESOLA .EQS. ""
$ THEN
$    CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'SeSoLa'SESOLA_OBJ' SeSoLa
$ ELSE
$!   (OpenSSL 0.9.5/6 has architecture-specific configuration file generated)
$    IF F$SEARCH("SSLROOT:[WASD]OPENSSLCONF_''ARCH_NAME'.H") .NES. "" 
$    THEN
$       COPY SSLROOT:[WASD]OPENSSLCONF_'ARCH_NAME'.H -
             SSLROOT:[INCLUDE.OPENSSL]OPENSSLCONF.H
$       PURGE /NOCONFIRM /NOLOG SSLROOT:[INCLUDE.OPENSSL]OPENSSLCONF.H
$    ENDIF
$!   (HTTPD v7.2ff requires structures defined in SSL_LOCL.H)
$    IF F$SEARCH("SSLROOT:[SSL]SSL_LOCL.H") .NES. "" 
$    THEN
$       COPY SSLROOT:[SSL]SSL_LOCL.H SSL_LOCL.H
$       PURGE /NOCONFIRM /NOLOG SSL_LOCL.H
$    ELSE
$       IF F$SEARCH("SSLROOT:[WASD]SSL_LOCL.H") .NES. "" 
$       THEN
$          COPY SSLROOT:[WASD]SSL_LOCL.H SSL_LOCL.H
$          PURGE /NOCONFIRM /NOLOG SSL_LOCL.H
$       ENDIF
$    ENDIF
$    CC 'CC_OPTIONS''CC_DEFINES' /NOWARN /OBJ='OBJ_DIR'SeSoLa'SESOLA_OBJ' SeSoLa
$    DELETE /NOCONFIRM /NOLOG SSL_LOCL.H;*
$ ENDIF
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ STMLF:   CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'StmLF    StmLF
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ SUPPORT: CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'Support  Support
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ THROTTLE:     CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'Throttle  Throttle
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ TRACK:     CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'Track  Track
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ UPD:     CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'Upd      Upd
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ VM:      CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'VM       VM
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$ WATCH:      CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'WATCH  WATCH
$ IF JUST .NES. "" THEN GOTO ENDCOMPILE
$!
$ VERSION: DATETIME = F$TIME()
$ IF F$EXTRACT(0,1,DATETIME) .EQS. " " THEN DATETIME = F$EXTRACT(1,99,DATETIME)
$ CC_DEFINES = CC_DEFINES - ")" + ",BUILD_DATETIME=""""""''DATETIME'"""""")"
$ CC 'CC_OPTIONS''CC_DEFINES' /OBJ='OBJ_DIR'VERSION  Version
$!
$ ENDCOMPILE:
$! 'F$VERIFY(0)
$!
$ IF P1 .EQS. "BUILD" .OR. P2 .EQS. "BUILD" .OR. -
     P3 .EQS. "BUILD" .OR. P4 .EQS. "BUILD" .OR. -
     P5 .EQS. "BUILD" .OR. P6 .EQS. "BUILD" THEN GOTO LINK
$ IF JUST .NES. "" THEN GOTO FINISHED
$!
$! ********
$! * LINK *
$! ********
$!
$ LINK:
$!
$ IF PERSONA_MACRO THEN MACRO PERSONA.MAR /OBJECT='OBJ_DIR'PERSONA_MAR
$!
$ SEARCH VERSION.H HTTPD_VERSION /OUTPUT=IMAGE_IDENT.LIS
$ OPEN /READ IMAGEIDENT IMAGE_IDENT.LIS
$ READ IMAGEIDENT IMAGE_IDENT
$ CLOSE IMAGEIDENT
$ DELETE /NOLOG /NOCONFIRM IMAGE_IDENT.LIS;*
$ IMAGE_IDENT = F$ELEMENT(1,"""",IMAGE_IDENT)
$ IF IMAGE_IDENT .EQS. "" .OR. IMAGE_IDENT .EQS. """" -
     THEN IMAGE_IDENT = "_UNKNOWN_"
$!
$ PROCEDURE = F$ENVIRONMENT("PROCEDURE")
$ PROCEDURE_DEV = F$PARSE(PROCEDURE,,,"DEVICE")
$ PROCEDURE_DIR = F$PARSE(PROCEDURE,,,"DIRECTORY")
$ LINK_OPT = PROCEDURE_DEV + PROCEDURE_DIR + "LINK_" + ARCH_NAME +".OPT"
$ IF F$TRNLNM("WASD_LINK_OPT","LNM$PROCESS") THEN CLOSE WASD_LINK_OPT
$ IF F$SEARCH("''LINK_OPT'") .NES. "" THEN DELETE /NOCONFIRM /NOLOG 'LINK_OPT';*
$!
$ OPEN /WRITE WASD_LINK_OPT 'LINK_OPT'
$ WRITE WASD_LINK_OPT "IDENT=""" + IMAGE_IDENT + """"
$ WRITE WASD_LINK_OPT OBJ_DIR + "Admin"
$ WRITE WASD_LINK_OPT OBJ_DIR + "Auth"
$ WRITE WASD_LINK_OPT OBJ_DIR + "AuthAgent"
$ WRITE WASD_LINK_OPT OBJ_DIR + "AuthCache"
$ WRITE WASD_LINK_OPT OBJ_DIR + "AuthConfig"
$ WRITE WASD_LINK_OPT OBJ_DIR + "AuthHTA"
$ WRITE WASD_LINK_OPT OBJ_DIR + "AuthHTL"
$ WRITE WASD_LINK_OPT OBJ_DIR + "AuthIdent"
$ WRITE WASD_LINK_OPT OBJ_DIR + "AuthVMS"
$ WRITE WASD_LINK_OPT OBJ_DIR + "Basic"
$ WRITE WASD_LINK_OPT OBJ_DIR + "Cache"
$ WRITE WASD_LINK_OPT OBJ_DIR + "CGI"
$ WRITE WASD_LINK_OPT OBJ_DIR + "CLI"
$ WRITE WASD_LINK_OPT OBJ_DIR + "Config"
$ WRITE WASD_LINK_OPT OBJ_DIR + "Control"
$ WRITE WASD_LINK_OPT OBJ_DIR + "Dcl"
$ WRITE WASD_LINK_OPT OBJ_DIR + "DECnet"
$ WRITE WASD_LINK_OPT OBJ_DIR + "Descr"
$ WRITE WASD_LINK_OPT OBJ_DIR + "Dir"
$ WRITE WASD_LINK_OPT OBJ_DIR + "Digest"
$ WRITE WASD_LINK_OPT OBJ_DIR + "Error"
$ WRITE WASD_LINK_OPT OBJ_DIR + "FAO"
$ WRITE WASD_LINK_OPT OBJ_DIR + "File"
$ WRITE WASD_LINK_OPT OBJ_DIR + "FileDot"
$ WRITE WASD_LINK_OPT OBJ_DIR + "Graph"
$ WRITE WASD_LINK_OPT OBJ_DIR + "HTAdmin"
$ WRITE WASD_LINK_OPT OBJ_DIR + "HTTPd"
$ WRITE WASD_LINK_OPT OBJ_DIR + "IsMap"
$ WRITE WASD_LINK_OPT OBJ_DIR + "Logging"
$ WRITE WASD_LINK_OPT OBJ_DIR + "MapUrl"
$ WRITE WASD_LINK_OPT OBJ_DIR + "MD5"
$ WRITE WASD_LINK_OPT OBJ_DIR + "Menu"
$ WRITE WASD_LINK_OPT OBJ_DIR + "Msg"
$ WRITE WASD_LINK_OPT OBJ_DIR + "Net"
$ WRITE WASD_LINK_OPT OBJ_DIR + "ODS"
$ IF PERSONA_MACRO
$ THEN
$    WRITE WASD_LINK_OPT OBJ_DIR + "Persona_macro"
$    WRITE WASD_LINK_OPT OBJ_DIR + "Persona_mar"
$ ELSE
$    IF VMS_VERSION .LT. 62
$    THEN
$       WRITE WASD_LINK_OPT OBJ_DIR + "Persona_stub"
$    ELSE
$       WRITE WASD_LINK_OPT OBJ_DIR + "Persona"
$    ENDIF
$ ENDIF
$ WRITE WASD_LINK_OPT OBJ_DIR + "Proxy"
$ WRITE WASD_LINK_OPT OBJ_DIR + "ProxyCache"
$ WRITE WASD_LINK_OPT OBJ_DIR + "ProxyMaint"
$ WRITE WASD_LINK_OPT OBJ_DIR + "Put"
$ WRITE WASD_LINK_OPT OBJ_DIR + "Request"
$ WRITE WASD_LINK_OPT OBJ_DIR + "Service"
$ IF OPENSSL
$    THEN WRITE WASD_LINK_OPT OBJ_DIR + "SeSoLa_SSL"
$    ELSE WRITE WASD_LINK_OPT OBJ_DIR + "SeSoLa"
$ ENDIF
$ WRITE WASD_LINK_OPT OBJ_DIR + "SSI"
$ WRITE WASD_LINK_OPT OBJ_DIR + "StmLF"
$ WRITE WASD_LINK_OPT OBJ_DIR + "Support"
$ WRITE WASD_LINK_OPT OBJ_DIR + "Throttle"
$ WRITE WASD_LINK_OPT OBJ_DIR + "Track"
$ WRITE WASD_LINK_OPT OBJ_DIR + "Upd"
$ WRITE WASD_LINK_OPT OBJ_DIR + "Version"
$ WRITE WASD_LINK_OPT OBJ_DIR + "VM"
$ WRITE WASD_LINK_OPT OBJ_DIR + "Watch"
$ IF OPENSSL
$ THEN
$    WRITE WASD_LINK_OPT "SSLROOT:[" + ARCH_NAME + ".EXE.SSL]LIBSSL.OLB/LIBRARY"
$    WRITE WASD_LINK_OPT "SSLROOT:[" + ARCH_NAME + ".EXE.CRYPTO]LIBCRYPTO.OLB/LIBRARY"
$ ENDIF
$ CLOSE WASD_LINK_OPT
$!
$ SET ON
$ SET VERIFY
$!
$ LINK'LINKMAP' 'TRACEQUAL' -
  /EXECUTABLE=HT_EXE:HTTPD'SESOLA_EXE'.EXE -
  'LINK_OPT'/OPTIONS
$!
$ SET PROTECTION=W:E HT_EXE:HTTPD'SESOLA_EXE'.EXE;*
$!
$!'F$VERIFY(0)
$ DELETE /NOCONFIRM /NOLOG 'LINK_OPT';*
$ PURGE /LOG 'OBJ_DIR' /KEEP=3
$!
$! ************
$! * FINISHED *
$! ************
$!
$ FINISHED:
$! 'F$VERIFY(0)
$ SET DEFAULT 'PREVDEFAULT'
$!(clean-up any WASD OpenSSL distribution logicals)
$ IF F$TRNLNM("SSLROOT","LNM$PROCESS") .NES. "" THEN DEASSIGN /PROCESS SSLROOT
$ IF F$TRNLNM("OPENSSL","LNM$PROCESS") .NES. "" THEN DEASSIGN /PROCESS OPENSSL
$!-----------------------------------------------------------------------------
